Incorporating SHAPE reactivity data
Constraining the Secondary Structure Predictions and Evaluations

Incorporate SHAPE reactivity structure probing data into the folding recursions by means of soft constraints. More...

Collaboration diagram for Incorporating SHAPE reactivity data:

## Files

file | constraints_SHAPE.h
| This module provides function to incorporate SHAPE reactivity data into the folding recursions by means of soft constraints.

## Functions

int | vrna_sc_add_SHAPE_deigan (vrna_fold_compound_t *vc, const double *reactivities, double m, double b, unsigned int options)
| Add SHAPE reactivity data as soft constraints (Deigan et al. method) More...
int | vrna_sc_add_SHAPE_deigan_ali (vrna_fold_compound_t *vc, const char **shape_files, const int *shape_file_association, double m, double b, unsigned int options)
| Add SHAPE reactivity data from files as soft constraints for consensus structure prediction (Deigan et al. method) More...
int | vrna_sc_add_SHAPE_zarringhalam (vrna_fold_compound_t *vc, const double *reactivities, double b, double default_value, const char *shape_conversion, unsigned int options)
| Add SHAPE reactivity data as soft constraints (Zarringhalam et al. method) More...
int | vrna_sc_SHAPE_to_pr (const char *shape_conversion, double *values, int length, double default_value)
| Convert SHAPE reactivity values to probabilities for being unpaired. More...

## Detailed Description

Incorporate SHAPE reactivity structure probing data into the folding recursions by means of soft constraints.

## Function Documentation

int vrna_sc_add_SHAPE_deigan | ( | vrna_fold_compound_t * | vc,
|  | const double * | reactivities,
|  | double | m,
|  | double | b,
|  | unsigned int | options
| ) |  |

`#include <ViennaRNA/constraints_SHAPE.h>`

Add SHAPE reactivity data as soft constraints (Deigan et al. method)

This approach of SHAPE directed RNA folding uses the simple linear ansatz

to convert SHAPE reactivity values to pseudo energies whenever a nucleotide contributes to a stacked pair. A positive slope penalizes high reactivities in paired regions, while a negative intercept results in a confirmatory ``bonus'' free energy for correctly predicted base pairs. Since the energy evaluation of a base pair stack involves two pairs, the pseudo energies are added for all four contributing nucleotides. Consequently, the energy term is applied twice for pairs inside a helix and only once for pairs adjacent to other structures. For all other loop types the energy model remains unchanged even when the experimental data highly disagrees with a certain motif.

See also
  For further details, we refer to [4].
  vrna_sc_remove(), vrna_sc_add_SHAPE_zarringhalam(), vrna_sc_minimize_pertubation()

Parameters

  vc | The vrna_fold_compound_t the soft constraints are associated with
  reactivities | A vector of normalized SHAPE reactivities
  m | The slope of the conversion function
  b | The intercept of the conversion function
  options | The options flag indicating how/where to store the soft constraints

Returns
  1 on successful extraction of the method, 0 on errors

int vrna_sc_add_SHAPE_deigan_ali | ( | vrna_fold_compound_t * | vc,
|  | const char ** | shape_files,
|  | const int * | shape_file_association,
|  | double | m,
|  | double | b,
|  | unsigned int | options
| ) |  |

`#include <ViennaRNA/constraints_SHAPE.h>`

Add SHAPE reactivity data from files as soft constraints for consensus structure prediction (Deigan et al. method)

Parameters

  vc | The vrna_fold_compound_t the soft constraints are associated with
  shape_files | A set of filenames that contain normalized SHAPE reactivity data
  shape_file_association | An array of integers that associate the files with sequences in the alignment
  m | The slope of the conversion function
  b | The intercept of the conversion function
  options | The options flag indicating how/where to store the soft constraints

Returns
  1 on successful extraction of the method, 0 on errors

int vrna_sc_add_SHAPE_zarringhalam | ( | vrna_fold_compound_t * | vc,
|  | const double * | reactivities,
|  | double | b,
|  | double | default_value,
|  | const char * | shape_conversion,
|  | unsigned int | options
| ) |  |

`#include <ViennaRNA/constraints_SHAPE.h>`

Add SHAPE reactivity data as soft constraints (Zarringhalam et al. method)

This method first converts the observed SHAPE reactivity of nucleotide into a probability that position is unpaired by means of a non-linear map. Then pseudo-energies of the form

are computed, where if position is unpaired and if is paired in a given secondary structure. The parameter serves as scaling factor. The magnitude of discrepancy between prediction and experimental observation is represented by .

See also
  For further details, we refer to [19]
  vrna_sc_remove(), vrna_sc_add_SHAPE_deigan(), vrna_sc_minimize_pertubation()

Parameters

  vc | The vrna_fold_compound_t the soft constraints are associated with
  reactivities | A vector of normalized SHAPE reactivities
  b | The scaling factor of the conversion function
  default_value | The default value for a nucleotide where reactivity data is missing for
  shape_conversion | A flag that specifies how to convert reactivities to probabilities
  options | The options flag indicating how/where to store the soft constraints

Returns
  1 on successful extraction of the method, 0 on errors

int vrna_sc_SHAPE_to_pr | ( | const char * | shape_conversion,
|  | double * | values,
|  | int | length,
|  | double | default_value
| ) |  |

`#include <ViennaRNA/constraints_SHAPE.h>`

Convert SHAPE reactivity values to probabilities for being unpaired.

This function parses the informations from a given file and stores the result in the preallocated string sequence and the FLT_OR_DBL array values.

See also
  vrna_file_SHAPE_read()

Parameters

  shape_conversion | String definining the method used for the conversion process
  values | Pointer to an array of SHAPE reactivities
  length | Length of the array of SHAPE reactivities
  default_value | Result used for position with invalid/missing reactivity values